/* ============================================================================
 * StopWatch:
 *
 * 
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/


#if !defined(StopWatch_H) 
#define StopWatch_H

#include <project.h>
#include "cytypes.h"        //macros

    
/***************************************
*        defines 
***************************************/
//#define  StopWatch_NumSensorsMax  (uint8) 8u    

//#define Tinact   20u        //us, Inactive before next signal
//#define TMtr0    50u        //Data bit 0 read,write 15-60us
//#define TMtr1    10u        //Data bit 1 read,write 1-15us
//#define RST_MAX 480u        //min 480 us
//#define T_conv  750u        //sensor conversion time ~750ms (12bit)
 
//#define HIGH 1u             // drive 1
//#define LOW  0u             // drive 0
//#define SET_ALL_OUT   255u  // select all [11111111] (select mask = 2^8-1)
//#define SET_ALL_INP   0u    // set to read - disable all
       
//#define T_OFF (int16) -4096 // missing sensor temperature, -4096 <->-256 C
//#define Str_OFF       "-"   // missing sensor report string
    
#define __STATIC_INLINE  static inline
 
#define CLOCK_FREQ     24000000u //clock and interrupt rates, in Hz
#define SYSTICK_MAXVAL 0x00FFFFFF //max allowed SysTick counter value for 24bit

uint8 volatile StopWatch_Reloads;
uint32 volatile StopWatch_Cycles;   
    
/***************************************
*        Types 
***************************************/
    
//typedef struct StopWatch_TSensor {
//    uint16 Temperature;     //encoded temperature reading
//    uint8  present;         //sensor present 
//} StopWatch_SensorBuffer;
//struct StopWatch_TSensor StopWatch_Sensor[8]; //array of sensors




//volatile CYBIT StopWatch_DataReady; //semaphore flag


/***************************************
*        Component parameters 
***************************************/

//#define StopWatch_NumSensors 

    


    
/***************************************
*        Function Prototypes 
***************************************/
 
void   StopWatch_Init();                     // init component
//void   StopWatch_Start();                     // init component
//uint32 StopWatch_Stop();                      // stop component
//__STATIC_INLINE uint32 StopWatch_Stop();                      // stop component
//static inline uint32 StopWatch_Stop();                      // stop component

__STATIC_INLINE void StopWatch_Start() 
{
    //StopWatch_isr_DataReady_StartEx(StopWatch_IRQDataReady); //set interrupt
    //SysTick->CTRL = 0;//disable, else first value is smaller
    StopWatch_Reloads = 0;
    SysTick_Config(SYSTICK_MAXVAL); //reset counter set to max value, 1-time,  will not reload 
    
    
    //manual, no interrupt->
    //SysTick->CTRL = 0;//disable
    //SysTick->LOAD = SYSTICK_MAXVAL-1;//16'777'215-1
    //SysTick->VAL = 0; //
    //SysTick->CTRL = 1;//enable 
}

__STATIC_INLINE void StopWatch_Stop()
{
    ///uint32 result = 0;
    ///result = (SYSTICK_MAXVAL-1) - (SysTick->VAL); //105 min 2 ticks in manual mode

    StopWatch_Cycles = (SYSTICK_MAXVAL-1) - (SysTick->VAL); //105 min 2 ticks in manual mode

            
    SysTick->CTRL = 0;//disable counter and interrupt after Stop
    
    //return (0);
}


/* [] END OF FILE */












//float StopWatch_GetTemperatureAsFloat  (uint8 index);  // convert to degC, returned as float
//int16 StopWatch_GetTemperatureAsInt100 (uint8 index);  // convert to degC x100, truncated to int16 
//char* StopWatch_GetTemperatureAsString (uint8 index);  // convert to degC, returned as string

//char* itoa10(int value, char* result);              // helper function, int->string

#endif // !defined(StopWatch_H) 

/* [] END OF FILE */
