/* ============================================================================
 * StopWatch:
 *
 * 
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/


#if !defined(`$INSTANCE_NAME`_H) 
#define `$INSTANCE_NAME`_H

#include <project.h>
#include "cytypes.h"        //macros

    
/***************************************
*        defines 
***************************************/
#define __STATIC_INLINE  static inline
 
#define CLOCK_FREQ     24000000u //clock and interrupt rates, in Hz
#define SYSTICK_MAXVAL 0x00FFFFFF //max allowed SysTick counter value for 24bit

uint8 volatile `$INSTANCE_NAME`_Reloads;
uint32 volatile `$INSTANCE_NAME`_Cycles;   
    
/***************************************
*        Types 
***************************************/
    

/***************************************
*        Component parameters 
***************************************/   

    
/***************************************
*        Function Prototypes 
***************************************/
 
void   `$INSTANCE_NAME`_Init();                     // init component
//void   `$INSTANCE_NAME`_Start();                     // init component
//uint32 `$INSTANCE_NAME`_Stop();                      // stop component
//__STATIC_INLINE uint32 `$INSTANCE_NAME`_Stop();                      // stop component
//static inline uint32 `$INSTANCE_NAME`_Stop();                      // stop component

__STATIC_INLINE void `$INSTANCE_NAME`_Start() 
{
    //`$INSTANCE_NAME`_isr_DataReady_StartEx(`$INSTANCE_NAME`_IRQDataReady); //set interrupt
    //SysTick->CTRL = 0;//disable, else first value is smaller
    `$INSTANCE_NAME`_Reloads = 0;
    SysTick_Config(SYSTICK_MAXVAL); //reset counter set to max value, 1-time,  will not reload 
    
    
    //manual, no interrupt->
    //SysTick->CTRL = 0;//disable
    //SysTick->LOAD = SYSTICK_MAXVAL-1;//16'777'215-1
    //SysTick->VAL = 0; //
    //SysTick->CTRL = 1;//enable 
    
    //CY_NOP; // add empty cycle
}

__STATIC_INLINE void `$INSTANCE_NAME`_Stop()
{
    ///uint32 result = 0;
    ///result = (SYSTICK_MAXVAL-1) - (SysTick->VAL); //105 min 2 ticks in manual mode

    `$INSTANCE_NAME`_Cycles = (SYSTICK_MAXVAL-1) - (SysTick->VAL); //105 min 2 ticks in manual mode

            
    SysTick->CTRL = 0;//disable counter and interrupt after Stop
    
    //return (0);
}


/* [] END OF FILE */












//float `$INSTANCE_NAME`_GetTemperatureAsFloat  (uint8 index);  // convert to degC, returned as float
//int16 `$INSTANCE_NAME`_GetTemperatureAsInt100 (uint8 index);  // convert to degC x100, truncated to int16 
//char* `$INSTANCE_NAME`_GetTemperatureAsString (uint8 index);  // convert to degC, returned as string

//char* itoa10(int value, char* result);              // helper function, int->string

#endif // !defined(`$INSTANCE_NAME`_H) 

/* [] END OF FILE */
